WIDTH=800
HEIGHT=600
S = math.max(WIDTH,HEIGHT)

function love.load()
	e = love.graphics.newPixelEffect [[
	extern number time;
	extern number distort;
	extern number chroma;
	extern Image buffer;

	vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
	{
		tc = vec2(1.0,1.0) - abs(2.0 * tc - vec2(1.0,1.0));
		number dist = dot(tc,tc);
		tc.x += sin(tc.y * 100 + time * 10.0) * .03 * distort;
		vec2 rb = vec2(1.0,1.0) * .002 * chroma;
		color = vec4(Texel(tex, tc+rb).r, Texel(tex, tc).g, Texel(tex, tc-rb).b, 1.0) * color * pow(dist, 0);
		return color + Texel(buffer, tc * .9) * .2;
	}
	]]
	e:send("time", 0);
	e:send("distort", .01);
	e:send("chroma", 10);
	t = 0
	love.graphics.setMode(WIDTH, HEIGHT)

	fb = love.graphics.newCanvas()
	rects = {}
	for i = 1,30 do
		rects[i] = {math.random(0,S)-S/2, math.random(0,S)-S/2}
	end

	with_effect = false
end

function love.draw()
	fb:clear()
	fb:renderTo(function()
		love.graphics.push()
		love.graphics.translate(WIDTH/2,HEIGHT/2)
		love.graphics.rotate(t)
		for i = 1,#rects do
			love.graphics.rectangle('fill', rects[i][1], rects[i][2], 70,40)
		end
		love.graphics.pop()
	end)

	if with_effect then
		love.graphics.setPixelEffect(e)
	end
	love.graphics.draw(fb)

	love.graphics.setPixelEffect()
	love.graphics.print((with_effect and 'With PixelEffect' or 'Without PixelEffect'), 10,10)
end

function love.update(dt)
	t = t + math.min(dt, 1/30)
	e:send("buffer", fb)
	e:send("time", t)
	e:send("chroma", 10 + math.sin(t) * 5)
	e:send("distort", .5 + math.sin(t) * .25)
end

function love.keypressed(key)
	if key == 'escape' then love.event.push('q') end
	with_effect = not with_effect
end
